import re

import taxonomy_config as config

injection1 = "(crafted(?! user auth)|malformed|forge(d|)|((via a (?!direct request)).*(invalid|(http header)|parameter))" \
             "|(hex encoded file extension)|(source ip address of a user)|(large integer in the content-length field)" \
             "|(?<!anti-)spoof|(dot|trailing dot)|(bluetooth nickname)|" \
            "(execute sql)|(sql injection)|(username that contains a domain name)|((incorrect|long) (username|offset))|" \
            "(post that sets volatile\.user\.administrator)|(directory traversal)|( flood)|" \
            "(certain (data|packet|(tiff file)|(regular expression)|character|(.*?(traffic|request))))|" \
            "(mac address of an authenticated)|(url that calls)|(helomoto)|(crlf sequence)|" \
            "(field that has more)|(options that involve a new home directory)|(vulnerability scans)|" \
            "((zero|negative|null(?! authentication)|invalid).*(value|length|header|field|option))|(argument injection))|(specifying a nonexistent)|" \
            "(long (string|url|password|argument|(http request)|(hci name)|(share list)|(dhcp packet)|(show arp command)))" \
            "|( replay(|ing))|(composed of)|(repeatedly trying to)|(large 'offered' value)|" \
            "(ip packet with the same source and destination ips)|(small ip fragments that do not form a complete)|" \
            "(modifying the original)|(false(( time)|) information)|(splitting the)|(format string)|" \
            "(large ((volume|number|amount) of))|(normally restricted management packets)|(filter web requests with large url)|" \
            "(modifying \(1\) the http user-agent)|(calling the 0x80002038 ioctl with a small size value)" \
            "|((sredirecturl|modified.*?) parameter)|(require extra time to process)|(broadcast arp packet)|" \
            "(configuration information via \(1\) /btvoyager_getconfig.sh)|((port|syn) scan)|((series|sequence) of.*?packets)|" \
            "(sending a vtp)|manipulat(ion|e)|modification|(empty password when using an external ldap)|(via post requests)|" \
            "(channel switch count less than)|(cookie value)|(creates files insecurely while initializing a usb printer)" \
            "|(man-in-the-middle)|(a \"tel:\" link)|( inject )|symlink|(\"\'\);)|(unspecified combination of tcp flags)|" \
            "(ssh traffic that occurs during management operations)|slash|(stress test)|(large value)|(segmented sccp message)|" \
            "(ssh credentials that attempt to change the authentication method)|(bad checksum)|(specific series of)"

injection2 = "(long series of as numbers)|(abnormal\" mgcp message)|(long tel: url)|(kqueues, which triggers a use after free)|" \
             "(subject alternative name fields)|(high volume of sip traffic)|(ipsec l2l tunnels)|(tls fragments)|" \
             "(corrupted magic value)|(via.*modified )|(context variables)|(path attributes)|(trick users into communicating)|" \
             "((multiple|many) (connection|(dhcpack message)|transition|source|tunnel))|(large udp packet)|(in the argument)|" \
             "((transit|fragmented|wlan) traffic)|((eigrp|multicast|(high volume of ipsec)) traffic)|(arge series of packets)|" \
             "(incorrect ldap authentication)|(banned certificate)|(making many)|(html entities)|(sipuri field in a sip invite)|" \
             "(sending http traffic)|(key was previously valid but later revoked)|(unspecified button sequence)|" \
             "(writing to the interrupt injection)|(range header that expresses)|(closing sequence)|(specifies zero bytes)|" \
             "(establishing many)|(side-channel)|(long (unicode string)|(cli command))|(port forwarding)|(mach ports)|" \
             "(using the kvm_set_sregs ioctl to set)|bracket|(overlapping opcodes)|(command followed by an)|" \
             "(length of less than one page)|(snmp trap)|(high rate)|(sending a short frame)|(sending an invalid response)|" \
             "(shell commands in an unspecified parameter)|(authentication in a virtual router redundancy protocol)" \
             "|(trigger an alert condition)|(cli commands and arguments)|(cli copy command)|(text-relocation instruction)" \
             "|(entering an arbitrary icloud account password value and a blank icloud account)|(polling frequently)|" \
             "(leveraging group-name similarity)|(via an application tag)|(absence of a certain orphaning)|" \
             "((certain|specific) (mpls|sip|udp) (packet|invite))|(using mprotect)|(non-standard ssl sessions)|(length field of zero)|" \
             "(sending a positive answer while a network name is being process)|symlink|(request-uri lacks a user name)" \
             "|(message without a content-type header)|(http request without a host header)|(length value of 1)" \
             "|(packet with the groupname in the id field)|(series of large packets)|(long icmp echo request)|(sending many.*?packet)|" \
             "(open audio stream message that enables)|(fragmented esp packet)|(ipv6 packet with an ipcomp header)"

injection3 = "(sip invite message accompanied by a)|cscsk46944|cscsl22355|(different ttl for each fragment)|" \
             "(write a file's content to standard error)|(multiple http requests for)|(network broadcast storm)|" \
             "(https request with 127.0.0.1)|(many as numbers)|(ike_auth request without)|(http post request to)|" \
             "(usb control message that triggers memory corruption)|(https (request|session), aka bug id)|" \
             "(sending.*?null pointer)|(in an abnormal manner)|(improperly disconnecting)|" \
            "|((malformed|truncated|segmented|(fragmented (esp|gre))|invalid|long|wappush|mpls|" \
            "zero(-|( in the ))length|crafted|large).*? " \
                "((?<!later )packet|command|(?<!\(1\) )update|batchbuffer|url(?!, \(2\))|((?<!unspecified )request)|" \
                "(?<!bootstrap )message|prefix|datagram|segment|method|radio|name|argument" \
                "|field|string|(session(?!, aka bug id cscuc79779))|data|descriptor|frame|" \
                "file|input|uri|attribute|value(?!, which)|username|" \
                "header|option|character|object|connection|response|(digest domain)|parameter|traffic|quer(y|ies)))|" \
             "(disconnecting an ssl session in an abnormal manner)|cscsm97220|cscso05337|(cookie received)|(ssdp reflection)|" \
             "(via.*(((null )|meta|)(character|((?<!pingstr)(?<!pingipaddr) parameter))))|(triggers unspecified ips signatures)|" \
            "(ssh management connections)|(certain (sip|dns|mpls|tcp|http) (message|packet|session|packet|request|response))" \
            "|(wappush messages)|(fragmented packets)|(sending packets that are not of a particular protocol)|(sequence of packets)|" \
             "(series of pptp session)|(source ip address of a previously)|(that lacks a from header)|(traffic amplification)"

control_hijack = "(((multiple|(stack|heap)-based) |)(buffer|integer) overflow)|(execute(.)*(code|command(?!s as arbitrary)|dll))" \
                 "|(format string)|(launch arbitrary applications)|" \
                 "(modifying the mchbar register)|(embedding commands)|(stack size)"

eavesdropping = "(through an untrusted)|sniff|(snmp by default in a manner)|( replay(|ing))|(intercepting these credentials)|" \
                "(specifies an internal ip address)|(watching a user)|(switching an ia32 process to 64-bit mode)|" \
                "( watching )|(incorrect visibility of the passcode-entry)|(read data that was sent to a printer)|" \
                "(obtain cleartext contents of)|(sends the configuration of the printer in cleartext)"

reversing = "hard(-|)coded (?!network)|" \
            "(?<!sniffing the username from the )(?<!base64-encoded )" \
            "               (?!sends username and password information in )cleartext" \
            "|(deobfuscating)|(file with base64 encoding)|(decrypting network traffic)|" \
            "(weak encryption|cryptography)|" \
            "(store.*((without proper protection)|cleartext))|(back door)|(reading the pwd field)|" \
            "(crack password)|(provides a critical random number)|(reading the physical memory locations)|" \
            "(has (\"|)public(\"|) as its default)|(watermark attack)|identifying|(examining encryption)|" \
            "((by|(related to)).*?reading)|(from ((a product)|another) installation)|" \
            "(reading extraneous fields in an html document)|( examining )|(decryption attack)"

malware = "(cross-site (scripting|image))|csrf|tunnel(ing (?!is used)|\ traffic)|(scripting code)|((\"|)blueline(\"|) attack)|" \
          "(redirecting a command)|(email containing an image url)|(userspace interruption of an internal function)|" \
          "(process that sets)|(inject(?!ion).*?script)|(sysenter to set an nt)|(different third-party application)|" \
          "(replacing csd executables)|(application to trigger an alert)|(bounds checking)|" \
          "(vectors related to \(1\) camera del)|(contains voice commands)|(capturing the outpost_ipc_hdr mutex)|" \
          "(phishing)|(log file viewer)|(modified cvpnd\.exe)|(enable key-based authentication to deployment server)|" \
          "(javascript(( (code|loop|(that writes)))|\.))|(via a web page containing)|(script opcode)|(trojan horse)|" \
          "(automatically force the user)|(facetime-audio: url)|(weak ssl encryption settings)|" \
          "(running of the app in the background state)|(deeply nested for loops)|(executing certain local software)|" \
          "(web page that accesses the easycalllite\.oce)|(modified batch file)|(blocked i/o message queues)"

brute_force = "(brute-forcing)|((?<!than )brute(-|\ )force)|(makes wlan passwords available)|(all possible image)|" \
              "(guessing this community)|enumerate"

normal_use1 = "(?<!large number of) ping(?!str)|((direct(ly|))(( url)|) (request|access))|registry|(does not follow file and mmap restrictions)|" \
             "(default .*?(password|username|account))|(access protected files by using the universal plug and play)" \
             "|(reading this variable)|(manual start of cvpnd.exe)|(autocomplete setting for the password)" \
             "|hard-coded|(listens to udp port)|(does not restrict)|(certain applications that switch to the default desktop)|" \
             "(reset the password for any user with an expired password)|(read and modify snmp variables)" \
             "|(?<!note: vectors 5 and 6 )(do(es|) not ((properly )|)(restrict|implement|manage|require|enforce|verify|perform)" \
                            "(( user)|( a)|( proxy)|) ((edited acls)|access|privilege|password|authentication(?!\.)|(.*rules))(?!, authorization))|" \
             "(user issues a send command)|(incomplete tacacs\+ configuration)|(only intended for testing)|" \
             "(not process certain attributes.*?bypass xauth)|(pressing ctrl-c at the username or password prompt)|" \
             "(assign permissions to themselves)|(not quickly time out)|(lists sensitive)|(using arbitrary snmp credentials)|" \
             "(do(es|) not properly ((set an administrative password)|authenticate))|(valid sip message)" \
             "|( log(\ |)in (?!command|attempt|session|phase|window|page))|(arbitrary port argument)|(has a default config)|" \
             "(privileges of dialog boxes)|(checks the client's uid)|(normal, properly formed ssl packet)|" \
             "(help facility in the supplicant gui is invoked)|(changing the group membership of user accounts)|" \
             "(mkfifo is running with the -m switch)|(replacing a backup archive)|(an acl to be improperly evaluated)|" \
             "(closing file descriptor 0, 1, or 2 and then invoking a setuid program)|(text searches)|" \
             "(null authentication and authorization value)|(execut(e|ing).* and then kill)|(world-readable permissions)" \
             "|(unauthorized files access)|(debug service on tcp port)|(navigating to the \"appearance\" dialog and selecting)|" \
             "(acl configuration with an invalid checksum)|(ftp bounce)|(lacking certain verification tags)|" \
             "(enabling the \"start before logon\")|(serves a web page to external clients)|(accessing administrative uri)|" \
             "(canceling the authentication dialog when accessing a sub-page)|(grants all local users the privileges)|" \
             "(accepts sip invite requests from arbitrary source)|(making a password change)|(blank password by default)|" \
             "(administrator role privileges to create, modify, or)|(connecting to tcp port)|(large require passcode time)|" \
             "(going to a specific link)|(make a phone call to an arbitrary number)|(disregards the access flag)|" \
             "(does not properly clear the search history)|(bind to a single ip address)|(disabling javascript)|" \
             "(accepting a meeting invitation)|(lowest security level interface)|(rejecting connection attempts)|" \
             "(does not enforce acl rules)|(accessing certain remapping registers)"

normal_use2 = "(sets incorrect.*?permission)|(performing meeting operations after account deactivation)|(list action)|" \
              "(does not properly (implement|validate) ((role-based access)|authentication))|(associating with the access point)" \
              "|(emergency(\ |-)call)|(invoking the apple menu)|(places a \"no login\" line)|(interact with the menu)|" \
             "(simultaneously ending two calls)|(via a rip update,)|(opens ports in upnp routers)|(visiting.*?\.php)|" \
             "(modbus 125 function code)|(standard (ssh|telnet))|(completing local web authentication quickly)|" \
             "(permission when building archive)|(does not compare the timestamp)|(extended use )|(disabling of browser javascript)" \
              "|(changes the admin password to an empty password)|(access.*account\.)|(default_reboot action)|(old shm interface\.)" \
              "|(device id in a port-create command)|(connecting to an aironet access point)|(incorrect state management)" \
              "|(level-0 asdm access)|(standard query)|(knowledge of the isdn phone)|(arbitrary verisign certificate)|" \
              "(attaching an ipv6 private subnet)|(speaking a telephone number)|(leveraging the sudo configuration)|" \
              "(weak system-object access control)|(leveraging membership in the operator group)|(undocumented)|(file:// uri)|" \
              "(leveraging a machine that had text selected)|(tapping )|(changing a ppp configuration)|(shm_info shmctl call)|" \
              "(the \"ldm ls -l\" command)|(remshd and/or telnet)|(connecting without using encryption)|(using them in requests)|" \
              "(does not use an authentication initialization)|(without authentication(,|) (?!via))|(network exposure was unintended)|" \
              "(without authentication\.)|(request to an arbitrary .cfg file)|(packet to udp port 916)|(certain operating-system misconfigurations)" \
              "|(does not allow the user to disable)|(accepts management packets from arbitrary vlans)|(empty systems list)|" \
              "(certain web interfaces)|(a packet of type \(1\) 0x2728)|(send snmp requests from any source ip address)|" \
              "(sending data over an established ssl connection)|(send packets that bypass)|(access restricted files\.)|" \
              "cscso10876|cscso58622|(via snmp requests, aka bug)|(via requests to.*?port)"

unknown = "((unknown|unspecified)((\ impact\ and|)((\ (remote|local))|)\ attack|) (vector|(.*?interaction,)))|" \
          "(via (unspecified|unknown))|(is a vague pre-advisory)|(via vectors involving)"

known_unknown_cves = [
    'CVE-2005-1680', 'CVE-2008-1248', 'CVE-2007-2512', 'CVE-2009-2213',
    'CVE-2005-2993', 'CVE-2010-1572', 'CVE-2007-2688', 'CVE-2010-1768',
    'CVE-2006-1509', 'CVE-2010-1809', 'CVE-2007-5549',
    'CVE-2006-1689', 'CVE-2010-1914', 'CVE-2009-4911',
    'CVE-2006-3226', 'CVE-2010-2977', 'CVE-2005-0364',
    'CVE-2006-3291', 'CVE-2010-4684', 'CVE-2005-0547',
    'CVE-2006-3552', 'CVE-2011-0387', 'CVE-2005-1709',
    'CVE-2006-4312', 'CVE-2011-3603', 'CVE-2005-4090',
    'CVE-2007-1066', 'CVE-2011-4012', 'CVE-2006-0096',
    'CVE-2007-2034', 'CVE-2014-3342', 'CVE-2006-2074',
    'CVE-2007-5008', 'CVE-2014-3703', 'CVE-2006-2355',
    'CVE-2007-5946', 'CVE-2014-7993', 'CVE-2007-5946',
    'CVE-2008-3803', 'CVE-2015-0606', 'CVE-2007-6044',
    'CVE-2005-3427', 'CVE-2007-3759', 'CVE-2009-1679'
]


def categorize_attack_method(cve):
    result = []
    if re.search(brute_force, cve.description):
        result.append(config.AttackMethod.Brute_Force)
    if re.search(malware, cve.description):
        result.append(config.AttackMethod.Malware)
    if re.search(eavesdropping, cve.description):
        result.append(config.AttackMethod.Eavesdropping_Sniffing)
    if re.search(control_hijack, cve.description):
        result.append(config.AttackMethod.Control_Hijacking)
    if re.search(reversing, cve.description):
        if cve.id == 'CVE-2005-4499':
            print re.search(reversing, cve.description).group(0)
        result.append(config.AttackMethod.Reversing)
    if (re.search(normal_use1, cve.description) or re.search(normal_use2, cve.description)) \
            and not re.search(control_hijack, cve.description) \
            and config.AttackMethod.Injecting_Crafted not in result:
        result.append(config.AttackMethod.Normal_Use)
    if (re.search(injection1, cve.description) or re.search(injection2, cve.description) or re.search(injection3, cve.description))\
            and len(result) == 0:
        result.append(config.AttackMethod.Injecting_Crafted)
    if len(result) == 0:
        if cve.id in known_unknown_cves or re.search(unknown,cve.description):
            result.append(config.AttackMethod.Unknown)
            return result
    if len(result) == 0:
        print cve.id, cve.description
        #exit(-1)
    return result