from random import random
from os.path import exists
import pickle
import taxonomy_config
import itertools
import numpy as np

from precondition import categorize_precondition
from attack_method import categorize_attack_method
from effect import categorize_effect
from vulnerability import categorize_vulnerability
from target import categorize_target


data = [[]]
data[0].append('CVE-ID')
data[0].append('Precondition')
data[0].append('AttackMethod')
data[0].append('Vulnerability')
data[0].append('Target')
data[0].append('Effect')



#global current_cve
current_cve = 'start'

def create_dataset():
    global current_cve, am_checked_cves, e_checked_cves
    cves = pickle.load(open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\cves.dump','r'))
    #min_i = 351
    #max_i = 360
    i = 0
    should_process = False
    checked_until = 'CVE-2005-0066'
    i_checked = 0
    checked = True
    for cve in cves:
        if cve.id == current_cve:
            should_process = True
        if should_process:
            print cve.id
            precon = categorize_precondition(cve)
            am = categorize_attack_method(cve)
            vuln = categorize_vulnerability(cve)
            tar = categorize_target(cve)
            eff = categorize_effect(cve)
            new_rows = list(itertools.product(precon,am,vuln,tar,eff))
            for row in new_rows:
                print row
            '''
            if len(new_rows) != 1:
                for row in new_rows:
                    print row
                print cve.description
                index = int(raw_input('Which index should we keep?'))-1
                data.append([cve.id] + list(new_rows[index]))
            else:
                data.append([cve.id] + list(new_rows[0]))
            '''
            i += 1
            current_cve = cve.id
    print 'Dataset prepared'
    with open('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\dataset_pickle.dump', 'w') as p:
        pickle.dump(data,p)
    with open('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\cve_pickle.dump', 'w') as p:
        pickle.dump(current_cve,p)
    print 'Dataset saved'


def get_max_length_of_column(column_num):
    max_len = 0
    for item in data[1:]:
        current_len = len(item[column_num])
        if current_len > max_len:
            max_len = current_len
    return max_len


def get_len_of_record(record):
    current_len = 0
    for item in record:
        current_len += len(item)
    return current_len

def fuzz_data(data):
    for record in data:
        for i in [1,2,3,4,5]:
            angle = (random()+0.0001)/5
            try:
                record.append(float(record[i]) + angle)
            except Exception as e:
                record.append(record[i])


if __name__ == '__main__':
    if not exists('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\dataset_pickle.dump'):
        print 'Previous data does not exists, building dataset...'
        global current_cve
        if exists('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\cve_pickle.dump'):
            current_cve = pickle.load(open('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\cve_pickle.dump','r'))
        else:
            current_cve = 'CVE-2005-0066'
        create_dataset()
    else:
        print 'Loading previous dataset...'
        data = pickle.load(open('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\dataset_pickle.dump', 'r'))
        print data
        current_cve = pickle.load(open('C:\\BME\\AIT\\repository\\attack taxonomy\\cve\\cve_categorizing\\cve_pickle.dump', 'r'))
        create_dataset()
        print 'Dataset loaded'

    fuzz_data(data)
    with open('figure_data_nofuzz.csv', 'w') as fig:
        for i in range(0, len(data)):
            for d in data[i]:
                fig.write(str(d) + ',')
            fig.write('dummy\n')

    data_to_plot = np.array(data)
    '''
    x = data_to_plot[:,0].astype(float)
    y = data_to_plot[:,1].astype(float)
    z = data_to_plot[:,4].astype(float)
    c = data_to_plot[:,2].astype(int)
    m = data_to_plot[:,3]

    fig = plt.figure()
    ax = Axes3D(fig)
    for x,y,c,m,z in data_to_plot:
        ax.plot([float(x)],[float(y)],[float(z)],marker=my_markers[int(m)])


    plt.show()
    '''