import re

import taxonomy_config as config

has_prec = "((which |)allow(?!s portal)|(make(s|) it)|(may cause))(?P<prec>.*?)(via|(, as demonstrated)|by |\.($|\"))"

lr_access   = "(((?<!as )(?<!the )(?<!\) )administrator(s|) (?!(privilege|account|access|credential|and|password|views|interface|via|for)))|" \
              "((logical domain)|authorized|(?<!as an )authenticated|(?<!bypass )local(?!((.)*network))|registered)(.)*" \
              "(attacker|user(?!,)|admin)|((?<!access the)(?<!custom web) application(?! (crash|files|data|hang)))|(remote client)|((?<!audio )gateway)|" \
              "((?<!remote )attacker(.)* (decrypt the information|(?<!execute arbitrary )command))|" \
              "(guest os)|((?<!uninitialized )memory locations(?!,|( or)))|(?<!\()process (?!and|outage|memory|for|restart|reload|crash|hang|failure)|" \
              "(obtain (passwords, user names, and)|(unspecified login access)|(sensitive memory-content))|(access unintended filesystem locations))"

public_av   = "((man-in-the-middle|remote( user-assisted|)(?! authenticated) attacker|(?<!cucm )server|(?<!the )" \
              "router(?! update)|(ocsp responder)|(ipp printer))|" \
              "((?<!local )(?<!context-dependent )attacker(s|)(.)*(bypass|gain (access|privilege)|forge|" \
              "(obtain (sensitive information)|authentication)|" \
                "redirect|hide|(denial of service)|(escape detection)|(execute arbitrary)|(defeat cryptographic))))"

misc        = "(((, )|\(|\ )when |code-signing|(crack password)|context-dependent|(membership in the operator group))"

physical    = "(physical access)|(Ethernet-over-USB interface)"

phy_prox    = "(physically proximate)|(internal network)"

unknown     = "(unknown|unspecified impact)"

known_unknown_cves = [
    'CVE-2005-3720',
    'CVE-2006-0096',
    'CVE-2006-2074',
    'CVE-2006-3738',
    'CVE-2006-4461',
    'CVE-2007-3465',
    'CVE-2007-4388',
    'CVE-2007-4590',
    'CVE-2007-6044',
    'CVE-2008-4594',
    'CVE-2009-3092',
    'CVE-2009-3093'
]

def categorize_precondition(cve):
    result = []
    prec = re.search(has_prec,cve.description)
    if prec:
        p = re.search(public_av, prec.group('prec'))
        if cve.id == 'CVE-2009-4455' and p:
            print prec.group('prec')
            print p.group(0)
            exit(-1)
        if re.search(phy_prox, cve.description):
            result.append(config.Precondition.Physically_Proximate)
        if re.search(physical, cve.description):
            result.append(config.Precondition.Direct_Physical)

        if re.search(lr_access, prec.group('prec')):
            if (config.Precondition.Physically_Proximate not in result) and (config.Precondition.Direct_Physical not in result):
                result.append(config.Precondition.Local_Remote_Access)

        if re.search(public_av, prec.group('prec')):
            if (config.Precondition.Physically_Proximate not in result) and (config.Precondition.Direct_Physical not in result):
                result.append(config.Precondition.Publicly_Available)

        if re.search(misc, cve.description) and len(result) == 0:
            result.append(config.Precondition.Misc)
        if result == []:
            print cve.id, cve.description
            exit(-1)
    elif re.search(misc, cve.description):
        result.append(config.Precondition.Misc)
    else:
        result.append(config.Precondition.Unknown)
        if cve.id in known_unknown_cves or re.search(unknown, cve.description):
            return result
        print cve.id, cve.description
        exit(-1)
    return result
    '''
    elif re.search(local_access_regex, cve.description):
        result.append(config.Precondition.LocalAccess)
    elif re.search(knowledge_regex, cve.description):
        result.append(config.Precondition.Knowledge)
    '''