import urllib2
import re
from time import sleep
import taxonomy_config as config
from bs4 import BeautifulSoup


hardware = "((control|esp|line|(modular services))(-|\ |)card(?!\ redundancy))|(pxe encryption)|(substation clock)|(srp reset)|" \
           "(persistent ike state)|(card (hang|reload|reset))|(modify the hardware timer)|(serial-interface outage)|" \
           "(ism module)|(plc modules.*\(module\ crash\))|watchdog|(plug ports into the routers)|" \
           "(route switch processor outage)"

os_firmware = "(bypass the filters)|(which generates an arp reply)|(modify permission)|prompt|" \
              "(arbitrary file)|(direct request to backup\.cfg)|(steal username)|" \
              "(access to file)|(default((\ administrator)|) (username|password|account|snmp))|" \
              "((buffer|stack) overflow)|(password configuration)|(directory traversal)|" \
              "(access restricted resources)|((obtain|gain) sensitive information)|(bypass xauth)|firmwarecfg|" \
              "(stores sensitive username)|(access control list)|(execute arbitrary((\ os)|) command)|" \
              "(gain(( (administrat((or)|(ive))|additional))|) privilege)|(enumerate valid username)|" \
              "(add a license)|(assign permission)|(dns \"client code,\")|(full path information)|" \
              "(gain (unauthorized|full|(read-write)|unspecified|(linux shell))((\ system)|) access)|" \
              "(determine valid groupname)|" \
              "((?!(for linux and windows before 3.2\(63\) stores a ))hard(-|)coded (account|credential|password|username))|" \
              "(read certain memory pages)|(distinct possible passwords)|(bypass intended top-up payment restriction)|" \
              "(fallback method)|(verify a subscription)|(bypass control methods)|(obtain (a|the) password)|" \
              "(management plane session loss)|(system crash)|(administrative password)|(access the telnet port)|" \
              "(tcp connections state table)|(bypass authentication)|(change the assigned role)|(back door)|" \
              "(authentication initialization function)|(access the administration interface)|" \
              "((?<!consequently\ )(modify|change|system) ((the\ )|(arbitrary\ )|)configuration)|" \
              "(upload new firmware)|(blocked new connections)|(obtain source code)|(code injection)|" \
              "(weak encryption \(xor encoding with a fixed byte mask\) for configuration information)|" \
              "(listening daemon)|(execute arbitrary code(?!( via crafted ike packets)))|(irewall services module)|" \
              "(ips configuration)|(kernel (oops|panic))|(connection filter)|(\ |\()flowd\ |(obtain superadmin access)|" \
              "(unresponsive interface)|(read usernames)|(obtain(((\ full|)\ administrative)|) privilege)|" \
              "(does not allow users to disable access)|(system privilege)|(hp-ux b.11.00 to b.11.23)|" \
              "(management packet)|(random-number generator)|(concentrator outage)|(obtain credentials)"


os_firmware2 = "(bypass network segmentation)|(software distributor)|(management control)|(tcl shell)|" \
              "(termination of packet passing)|((cpu|memory) consumption)|(reset the password)|(list contents of)|" \
              "(access an administrative menu)|(create users)|(obtain passwords)|(change the ownership)|" \
              "(correctly verifying x\.509)|(bypassing intended router acl)|(bypass traffic inspection)|" \
              "(files outside of the vault)|(system policy evasion)|(access the management inferface without authentication)|" \
              "(limit dns service access)|(^cisco ios allows remote attackers to cause a denial of service \(crash\))|" \
              "(reading \(1\) files)|(obtain access to system-management tools)|(bypass ips signatures)|(detection of http traffic)|" \
              "(obtain helpdesk-equivalent privileges)|(bypass intended access restriction)|(upload files)|" \
              "(mobility extension)|(crash\) by sending a crafted packet to port 5060/udp)|(ips crash)|" \
              "(hybrid mode)|(getnetbyname in gnu c library)|(direct request(?!\ to\ an\ unspecified\ ospf\ url))|" \
              "(website whitelist protection)|(bypass intended restrictions on network traffic)|(file-handle exhaustion)|" \
              "(bypass authorization)|(access to arbitrary subnets)|(modify the cwmp configuration)|(ip stack in cisco)|" \
              "(nacattack)|(read any configuration page)|(gain the privileges of the superusers group)|" \
              "(network processing unit)|(blocked router update processing)|(backup-encryption password)|" \
              "(bypass intended resource-access restriction)|(obtain access to an arbitrary sponsor)|" \
              "(obtain network device administrator privilege)|(read device-discovery passwords)|" \
              "(authentication-state modification)|(bypass role-based access)|(closing of tcp ports)|" \
              "(enumerate(\ user|) account)|(install arbitrary firmware)|(obtain shell access)|(rpd restart)|" \
              "(obtain .*? information(?!,\ via\ a\ crafted\ tls))|(obtain linux root access)|(write to files)|" \
              "(execute commands)|(firewall rule)|((gain|obtain) administrative access)|" \
              "(voice vlan)|(unrestricted critical resource)|(client's uid)|(blank password)|(buffer over-read)|" \
              "(grants all local users the privileges of gid 0)|(inter-daemon communication)|(obtain the ios version)|" \
              "(defeat cryptographic protection)|(defect-mode transition)|" \
              "(dnp3 process gateway)|(read configuration files)|(obtain cleartext passwords via a brute-force)|" \
              "(reading the site security key)|(get_system_info command in ignite-ux)|" \
              "(wan access to the web interface)|(perform administrative actions)|(change the admin password)|" \
              "(interface for which network exposure was unintended)|(sniffed digest authentication credentials)|" \
              "(obtain server memory content)|(obtain authentication credentials)|(obtain unspecified access)|" \
              "(degraded networking)|(unspecified vulnerability in juniper junos)|" \
              "(obtain the logon password)|(obtain current login status)|(upload malformed firmware)"

os_firmware3 = "(obtain potentially sensitive information)|" \
               "(hardcoded (service|application) password)|(modify firmware)|" \
              "(obtain sensitive password)|(obtain sensitive encrypted-password)|(sensitive credential)|" \
              "(execute arbitrary linux command)|(bypass intended code-signing restriction)|(calculate credentials)|" \
              "(ipv4 address attachment outage)|(connectivity outage)|(routing process crash)|(tunnel filter)|" \
              "(partition encryption key)|(obtain authentication data)|(guess password)|(certificate authority)|" \
              "(bypass intended proxying restriction)|(em driver bock)|(router protocol daemon crash)|" \
              "(delete a superuser account)|(bypass control-plane acl)|(dropped session)|(corrupted route target)|" \
              "(networking subsystem in apple ipod)|(auto-completion mechanism)|" \
              "(bypass vpn authentication)|(read arbitrary files)|" \
              "(session exhaustion)|hypervisor|(network outage)|(default \"isp\" account)|(gain root privilege)|" \
              "(input(\ |-)queue)|(https web interfaces on the aten)|(shared memory partition)|(voice-services outage)|" \
              "(tcp services outage)|file-descriptor|(session reset)|(bypass the passphrase requirement)|" \
              "(weak hash algorithm for passwords)|" \
              "(recovery key)|(access restricted file)|(in the advanced management module firmware before 2.50g)|" \
              "(console hang)|(syslog outage)|(recovery mode)|(ipsec tunnel loss)|(bypass ntlmv1 authentication)|" \
              "(bypass acl)|(interface queue)|(flood-protection feature)|" \
              "(unspecified vulnerability in cisco nx-os)|(cisco ios xr 3.8.1 and earlier allows)|(memory locations)|" \
              "(send arbitrary udp packets)|(over-the-air provisioning)|timestend|(seil/b1 firmware)|(workgroup bridge)|" \
              "(discover a group password)|(peering reset)|(offline backup mechanism)|(world-readable permission)|" \
              "(report the wireless network)|(gain console privilege)|(accessibility component)|(read a password)|" \
              "(policy definition evaluator)|(discover administrator credentials)|(read password)|(passcode lock)|" \
              "(block exhaustion)|(tcp socket exhaustion)|(bypass smtp inspection)|(bypass a certificate ban)|" \
              "(execute arbitrary cli command)|(write to these log files)|(esxi host)|cscth60993|csctj44534"

os_firmware4 = "(execute arbitrary program)|(fusion middleware)|(web management portal)|(bypass the device lock)|" \
              "(default root password)|(gain host os privileges)|(read the start-up configuration)|rnautility\.dll|" \
              "(modify network management system)|(default \(1\) username)|(execute arbitrary operating-system commands)|" \
              "(inject arbitrary command)|(obtain username)|(master entry consumption)|(dnp3 feature)|(detection rules)|" \
              "(execute arbitrary dll functions)|(router advertisement daemon)|(bypass intended directory-access)|" \
              "(obtain the administrator password)|(establish arbitrary port mapping)|computepassword|" \
              "(wincc flexible runtime does not perform authentication)|(discover the pin value)|(policy feature)|" \
              "(obtain sensitive authentication information)|(obtain access to diagnostic information)|" \
              "(establish (ssh|telnet) connections from arbitrary source)|(replace the configuration)|cscty73682|" \
              "(factory account)|(maximum password length)|(modify data on arbitrary remote share)|csctr44822|" \
              "(web-based administration)|(perform arbitrary action)|(obtain access by leveraging knowledge)|" \
              "(discover credential|account)|(traffic-inspection outage)|(discover the password)|(management outage)|" \
              "(enumerate vlan)|(establish undetected concurrent logins)|(bypass intended upload restriction)|" \
              "(execute arbitrary debug-shell command)|(obtain sensitive networking-services information)|" \
              "(pfe restart)|(obtain sensitive configuration-file information)|(rip service engine)|cscub45809|" \
              "(bgp service reset)|(access the network)|(condor_schedd restart)|(multiple connection resets)|" \
              "(discover password)|logreceiver\.exe|load-balancing|(spurious errors)|(command restriction)|" \
              "(obtain a username listing)|(device configuration)|(read files)|(privilege restriction)|cscud15673|" \
              "(enumerate group)|(read arbitrary)|(ethernet frame-forwarding)|(modify the firmware)|(the kernel in netbsd)|" \
              "(dnp3 driver)|(dnp3 slave service)|(dnp master driver)|(trojan horse firmware)|(enumerate directories)|" \
              "(enumerate files)|(obtain sensitive configuration)|(bypass the encryption policy)|(discover username)|" \
              "(obtain sensitive stack-trace information)|(connection-table exhaustion)|(rip process)|(slapd crash)|" \
              "(default wpa2 psk passphrase)|(modify data)|(read images)|(change the operation mode)|cscuj45353"

os_firmware5 = "(bypass intended policy restriction)|(ospfv3 functionality)|(transition to the interrupt state)|" \
              "(list os user account)|(ns processing outage)|(home automation firmware)|(bypass access control)|" \
              "(obtain sensitive device information)|(packet processor crash)|(discover sensitive information)|" \
              "(sufficiently large number of possible wpa-psk passphrase)|(bypass security group restriction)|" \
              "(bypass ldap authentication)|(execute operating-system commands)|(dyld in apple ios)|(nat implementation)|" \
              "(obtain cleartext data from an arbitrary iac installation)|(analysis engine process outage)|(kernel driver)|" \
              "(zone-based firewall implementation)|(tacacs\+ command-authorization implementation)|(modify user credentials)|" \
              "(change the administrator password)|(in the linux kernel)|(management module reboot)|(modify administrative credentials)|" \
              "(bypass kernel-mode hook handlers)|(capturing credentials)|(modify user information)|(cleartext ipmi credentials)|" \
              "(modify appliance preferences)|(internal information about the module)|(shm subsystem in the linux kernel)|" \
              "(the kernel in apple ios)|(initialize kernel memory)|(change a configuration)|(access the system controller)|" \
              "(control-plane access-list)|(ips software)|(obtain root access)|passwordcheck|(settings in apple ios)|" \
              "(obtain potentially sensitive version information)|(bypass code-signing requirements)|(kernel crash)|" \
              "(hardcoded administrative credentials)|(obtain at level access)|(packet loss)|(bypass the aslr protection)|" \
              "(extra multicast states on the core routers)|(writing to a phone's filesystem)|(execute arbitrary php code)|" \
              "(ssl certificate checking)|(file existence)|(modify files)|(unauthorized (operations|action))|" \
              "(gain \"unauthorized access\")|(measurement, aggregation, and correlation engine \(mace\) implementation)|" \
              "(as administrators)|(snmp trap agent service)|(hijack the x11 forwarding port)|" \
              "(multi protocol label switching \(mpls\) forwarding infrastructure \(mfi\) in cisco ios)|" \
              "(add a port forwarding rule)|(hijack the authentication)|(kernel assertion panic)|(during a context switch)|" \
              "(this issue requires root privileges to exploit)|(bypass ipc permissions)|(php((\ remote)|) file inclusion)|" \
              "(bypass the locked state)|(read arbitrary text files)|(pptp-alg component)|(exhaustion of the account supply)|" \
              "(obtain a privileged terminal session)|(hardcoded tbus 2 credentials)|(obtain the administrator user name)|" \
              "(perform other unspecified sinit acm functions)|(change.*? password)|(discover a username)|(read the private key)|" \
              "(kext management in apple ios)|(execute arbitrary snmp commands)|(client machine(,|) and execute this)|" \
              "(dot11t/t_if_dot11_hal_ath.c in cisco ios)|(aaa functionality)|(acl implementation in cisco ios)|" \
              "(general responder implementation)|(cifs implementation)|(/output control implementation)|" \
              "(label distribution protocol \(ldp\) functionality)|cscul49309|" \
              "(ipv6 virtual fragmentation)|(auto-update implementation)|(ioacceleratorfamily api implementation)"

application = "(squid)|(process restart)|(web page that accesses the easycalllite\.oce)|(bypass malware filtering)|" \
              "(http access restriction)|(encryption keys)|(application crash)|(ftp (bounce|daemon))|csctd14474|" \
              "(estara sip softphone)|(avaya ip softphone)|(http service crash)|(client crash)|(media snapshot implementation)|" \
              "((?<!addslashes\ to\ conduct\ )sql injection)|(loss of service)|(misinterprets a menu button)|" \
              "(redirect users to other websites)|(proxy arbitrary tcp connection)|(eval injection vulnerability)|" \
              "(\(process hang\))|(httpd crash)|(audio quality loss)|(spoof the address bar)|(url rewriting and html rewriting)|" \
              "(obtain the installation path)|(obtain root privilege)|(application hang)|(open redirect)|" \
              "(process reload)|(web-interface outage)|(javascript delays)|snmpd|(loss of voice services)|" \
              "(unspecified vulnerabilities in ageet agephone)|(blocked call reception)|(widcomm bluetooth)|" \
              "(captcha implementation)|(ping of death)|(web proxy service)|(spoof a user interface)|" \
              "(cross-application scripting)|(phonectrl\.exe)|(ssdp reflection)|(content security management appliance)|" \
              "(redirect users to)|(download private photos)|(ssh daemon crash)|(e-mail interaction manager)|" \
              "(excessive data processing)|(master protocol application)|(sms handler)|(unistim ip softphone)|" \
              "(ibm websphere)|(file sharing hang)|^vino|(trick the iphone user into)|(make arbitrary phone calls)|" \
              "(default ftp password)|(web interface crash)|(crack password)|(service interruption)|clickjacking|" \
              "(ccm service restart)|(sm@rtclient app)|(launch unintended calls)|(resolver(?!s, related to))|" \
              "latency|(double free vulnerability in perl 5.8.8 allows)|(clear the search history)|(user token)|" \
              "(inject arbitrary ((http header)|html|(web script)))|(autonomic networking infrastructure)|" \
              "(smart call home)|(sql command)|(does not disable it until safari is restarted)|(inject web pages)|" \
              "(uikit component)|(media (manager|player))|emweb|(session manager component)|(apache openoffice\.org)|" \
              "mysql|(ip phone personal address book)|(mail component)|(profiles component)|(gui outage)|" \
              "(simple login manager)|traceback|(computer telephony integration)|(aka callmanager)|(http client)|xarrow|" \
              "(oracle communications application)|jpppd|(open phone abstraction library)|(application exit)|" \
              "(captive portal application)|cscuh12488|tweetbot|misecuremessages|(rdp crash)|\(unregistration\)|" \
              "(routing-engine reload)|(alstom e-terracontrol)|(service disruption)|(execute arbitrary javascript code)"

application2 = "smartposter|(session border controller)|(exchange support component)|crlf|(spoof the user interface)|" \
              "(discover wireless lan controller mac addresses)|((?<!subject\ headers\ in\ )e-mail message)|csctc38985|" \
              "bitcoind|(uuencode inspection engine)|(the web browser in symbian os)|(webkit in(\ apple|) safari)|" \
              "(retrieve the content of remote urls from one domain)|(status code portion of an http response)|csctc47823|" \
              "\ ognl\ |(notes traveler)|(web filter)|(bypass javascript detection)|(use-after-free and parsing error)|" \
              "(fabric(\ |-)interconnect component)|(obtain potentially sensitive software-version information)|" \
              "(asterisk open source)|(unstable service)|(predictable session id)|" \
              "(assertion failure and daemon exit)|(internet streamer application)|(service (crash|hang))|(video unit)|" \
              "(platform-sw component)|((?<!internal)\ database\ )|(home screen component)|(cogent datahub)|cscua13166|csctu32832|" \
              "(web content)|(siemens automation license manager)|(server in certec edv)|(web server (?!name))|(video feeds)|" \
              "cm(p|b)webserver\.dll|factorytalk|webaccess|(services crash)|(route processor crash)|(webui outage)|" \
              "(fibre channel over ip)|(crosstalk information)|(vpnagentd process crash)|cscsr74439|" \
              "(c3-ilex eoscada)|(emerson deltav)|(packet transmission outage)|(downloader implementation)|csctc37188|" \
              "(web application)|(intended url restriction)|(daemon crash)|(pro-face)|(spoke crash)|(http module)|" \
              "(sharepoint application)|(npapi plugin interface)|(http service outage)|(video-capture outage)|csctc62362|" \
              "(database-query)|(webcli component)|(bandwidth-pool consumption)|(application slowdown)|cscsz95423|csctj87367|" \
              "(webex training center)|(xml api management service)|(session fixation)|(ssl/tls outage)|cscsu31800|" \
              "(video engine)|(modify the clp interface)|cscub54349|(connection-database)|mediasense|" \
              "(video and image data)|(\(hang or reboot)|(ui unavailability)|(\(administration interface outage\))|cscth43256|" \
              "(bypass sec_db authentication)|(monitoring-service outage)|(bypass an intended password requirement for itunes)|" \
              "(to(\ a|) virtual (ethernet|supervisor) module)|(scada data gateway)|(radiolinx controlscape)|csctg62855|" \
              "(in the apache http)|(tmssnmpservice\.exe in telepresence manager)|(incorrect memory access)|cscth39586|" \
              "(web manager implementation on d-link japan des-3800 devices)|csctd17310|csctf66305|csctd39629|csctc61990|" \
              "(authentication-proxy implementation)|(web manager implementation)|(web management interface in siemens ruggedcom ros before 3.11)"

device = "((device|controller)\ (re(boot|start|load)|crash|hang))|(denial of service\.)|(bandwidth consumption)|(phone restart)|" \
         "(denial of service (?!\())|(\(crash\) via an ipsec ike)|(connectivity and array access loss)|" \
         "(disconnect all wifi clients)|(resource consumption)|\(restart\)|(device outage)|" \
         "(traffic consumption)|(lock-screen protection)|(accepts sip invite requests from arbitrary source)|" \
         "(continuous ring)|(traffic amplification)|(arp storm)|(device reset)|(device inoperability)|" \
         "(extra multicast states on the core routers)|(trusted host value of 0\.0\.0\.0)|(bypass the lock screen)|" \
         "(portal outage)|(make a phone call)|(unstable performance)|(networking outage)|(\(device restart\))|" \
         "(unspecified vulnerability on the asus wl-500w wireless router)|(obtain location information)|" \
         "(disk consumption)|(traffic storm)|(make telephone call)|(connection limit exceeded)|(wi-fi outage)|" \
         "(ethernet outage)|(bgp neighbor flapping)|(continuous restart)|(communication outage)|(transmission outage)|" \
         "(access point reload)|(rtac master devices)|(obtain esn and min values)|(network-element reload)|" \
         "(aicloud feature)|(obtain telephone number)|(call outage)|(ipv4 and ipv6 transit outage)|(system reboot or shutdown)|" \
         "(denial of service \(reboot)|(panic and reboot)|(\(unresponsive device\))|(device reload)|(port hang)|" \
         "(triggers improper handling of the timing)|(snmpv2c implementation)|(phoenix contact fl il 24 bk-pac)|" \
         "instability|unresposiveness|(unstable operation)|(router reset)|(loss of communication)|(\(resource exhaustion)"

protocol = "(design of tcp)|(tcp implementation)|(through an untrusted network)|(spoofed cisco discovery protocol)|" \
           "(man-in-the-middle(?!\ attackers\ to\ execute\ arbitrary))|(unencrypted traffic)|" \
           "(internet key exchange)|(sent to a printer)|(dhcp implementation)|(vlan trunking protocol (vtp) implementation)|" \
           "(to eavesdrop by )|(disable wi-fi encryption)|(extensible authentication protocol)|" \
           "(encrypt credentials in transit)|(rc4 setup key)|(discover credentials by sniffing)|" \
           "(the snmp implementation)|(inject cells)|(session initiation protocol (sip) implementation)|" \
           "(multicast group as the destination)|(ipsec driver)|(bypass snmp authentication)|(snmpv3 component)|" \
           "(the dns protocol, as implemented in)|(hijack forwarded x connections)|(replay attack)|" \
           "(obtain the cleartext content of network)|(route-injection)|(ipv6 neighbor discovery protocol)|" \
           "(temporal key integrity protocol)|replaying|(phase 1 sa exhaustion)|(sip implementation)|" \
           "(implement tls and ssl)|(ipsec vpn implementation)|(neighbor discovery \(nd\) protocol)|(ikev1 implementation)|" \
           "(persistent ike state)|(ntp implementation)|(radius outage)|(locator/id separation protocol)|" \
           "(obtain plaintext messages)|(wpa2 implementation)|(ospf implementation)|(ssl/tls layer outage)|" \
           "(ieee c37\.118)|(obtain the wpa or wpa2 pre-shared key)|(ikev2 implementation)|(ipsec implementation)|" \
           "(bgp implementation)|(obtain ecdsa nonces)|(ike implementation)|(icmpv6 implementation)|(igmpv3 implementation)|" \
           "(session initiation protocol \(sip\) implementation)|(snmpv2c implementation)|(h.323 implementation)|" \
           "(h.225.0 implementation)|(mgcp implementation)|(ppp implementation)|" \
           "(sshv2 implementation)|(ssl(\ |)vpn implementation)|(ssh implementation)|(pptp(\ alg|) implementation)|" \
           "(ipv6 implementation)|(mldp implementation)|(igmp implementation)|(dhcpv6 implementation)|(lldp implementation)|" \
           "(mldp implementation)|(ssl implementation)|" \
           "(vlan trunking protocol \(vtp\) implementation)|(protocol.*?implementation)|(transport layer security \(tls\) implementation)"

known_unknown_cves = [
    'CVE-2013-4937', 'CVE-2014-6598'
]

def categorize_target(cve):
    result = []
    if re.search(hardware, cve.description):
        result.append(config.Target.Hardware)
    if (re.search(os_firmware, cve.description) or re.search(os_firmware2, cve.description)
        or re.search(os_firmware3, cve.description) or re.search(os_firmware4, cve.description)
        or re.search(os_firmware5, cve.description)) and cve.description.find('mysql database connection') < 0\
             and cve.description.find('reading the verbose response data') < 0\
             and cve.description.find('oracle database') < 0:
        result.append(config.Target.OS_Firmware)
    if (re.search(application, cve.description) or re.search(application2, cve.description))\
            and cve.description.find('buffer overflow') < 0:
        result.append(config.Target.Application)
    if re.search(device, cve.description) and cve.description.find('buffer overflow') < 0 \
                                          and cve.description.find('implementation') < 0\
                                          and cve.description.find('reading the verbose response data') < 0\
                                          and len(result) == 0:
        result.append(config.Target.Device)
    if re.search(protocol, cve.description):
        result.append(config.Target.Protocol)
    '''
    if len(result) == 0:
        print cve.id, cve.description
        #exit(-2)
    '''
    return result

