from enum import Enum

class Precondition(Enum):
    Local_Remote_Access     = 1
    Publicly_Available      = 2
    Physically_Proximate    = 3
    Direct_Physical         = 4
    Misc                    = 5
    Unknown                 = 6

class AttackMethod(Enum):
    Injecting_Crafted       = 1
    Control_Hijacking       = 2
    Eavesdropping_Sniffing  = 3
    Reversing               = 4
    Malware                 = 5
    Brute_Force             = 6
    Normal_Use              = 7
    Unknown                 = 8

class Effect(Enum):
    DoS                     = 1
    Code_Execution          = 2
    Integrity_Violation     = 3
    Information_Leakage     = 4
    Illegitimate_Access     = 5
    Financial_Loss          = 6
    Degrading_Level_of_Protection = 7 # CVE-2007-2688
    Other                   = 8
    Unknown                 = 9

class Vulnerability(Enum):
    Programming_Errors      = 1
    Web                     = 2
    Weak_Access_Control     = 3
    Improper_Crypto         = 4
    Insecure_Config         = 5
    Unknown                 = 6

class Target(Enum):
    Hardware                = 1
    OS_Firmware             = 2
    Application             = 3
    Device                  = 4
    Protocol                = 5