import urllib2
from time import sleep
import os.path

from bs4 import BeautifulSoup

from cve_preparation import config


products = {}
vendors = {}

website = 'http://www.cvedetails.com/cve/'

def get_table_from_website(cve_id):
    if os.path.exists('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\cve_details\\' + cve_id + '.html'):
        with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\cve_details\\' + cve_id + '.html', 'r') as data:
            html = data.read()
    else:
        try:
            response = urllib2.urlopen(website + cve_id)
        except Exception as e:
            print 'Problem accessing website of ' + cve_id + '. Retrying...'
        html = response.read()
        webpage = open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\cve_details\\' + cve_id + '.html', 'w')
        webpage.write(html)
        webpage.close()
    soup = BeautifulSoup(html, 'html.parser')
    try:
        count_table = soup.select('table#vulnversconuttable')[0]
        type_table = soup.select('table#vulnprodstable')[0]
        return count_table, type_table
    except:
        try:
            print 'No count table'
            return '', soup.select('table#vulnprodstable')[0]
        except:
            print 'No products table'
            return '', ''

def makelist(table):
    result = []
    allrows = table.findAll('tr')
    for row in allrows:
        result.append([])
        allcols = row.findAll('td')
        for col in allcols:
            thestrings = [unicode(s) for s in col.findAll(text=True)]
            thetext = ''.join(thestrings)
            result[-1].append(thetext)
    return result

def get_targets(cve_id, description):
    res = []
    count_table = False
    for i in range(0, 15):
        try:
            print 'Processing website of ', cve_id
            count_table, type_table = get_table_from_website(cve_id)
            break
        except Exception as e:
            print e.message
            print 'Problems with connection. Retrying...'
            sleep(30)
    if not count_table or count_table == '':
        print 'Could not process website'
        try:
            products['NoData'] += 1
        except:
            products['NoData'] = 1
        try:
            vendors['NoData'] += 1
        except:
            vendors['NoData'] = 1
        return [config.Target(vendor='',
                             product='',
                             type=config.TargetType.NoData)]
    type_table = makelist(type_table)
    for i in makelist(count_table):
        if len(i) == 3:
            vendor = i[0].strip().lower()
            product = i[1]
            type = 'NoData'
            for p in type_table:
                found = False
                for l in range(0,len(p)-1):
                    if product == p[l].strip():
                        type = p[1].strip().lower()
                        if type == 'hardware':
                            t_type = config.TargetType.Hardware
                        elif type == 'os':
                            t_type = config.TargetType.OS
                        elif type == 'application':
                            t_type = config.TargetType.Application
                        else:
                            t_type = config.TargetType.NoData
                        found = True
                        break
                if found:
                    break

            vendor_product = type + '__' + vendor + '__' + product.strip().lower()
            res.append(config.Target(vendor=vendor,
                                     product=product,
                                     type=t_type))
            try:
                products[vendor_product] += 1
            except:
                products[vendor_product] = 1
            try:
                vendors[vendor] += 1
            except:
                vendors[vendor] = 1
    return res

balanced = []

if __name__ == '__main__':
    '''
    global balanced
    with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\balanced_dataset.txt', 'r') as subset:
        for line in subset:
            balanced.append(line.strip())
    '''
    with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\cve_embedded_from2005.csv', 'r') as cves:
        for line in cves:
            data = line.split(';;;')
            cve_id = data[0]
            '''
            if cve_id in balanced:
                get_targets(cve_id,'')
            '''
            get_targets(cve_id,'')
    with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\vendors_subset.csv', 'w') as v:
        for ven in vendors.keys():
            v.write(str(ven)+','+str(vendors[ven]) + '\n')
    with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\data\\products_subset.csv', 'w') as p:
        for ven in products.keys():
            p.write(str(ven)+','+str(products[ven]) + '\n')