import urllib2
from bs4 import BeautifulSoup
from time import sleep
import pprint


count = {}
website = 'http://www.cvedetails.com/cve/'
cves_to_search = []

def makelist(table):
  result = []
  allrows = table.findAll('tr')
  for row in allrows:
    result.append([])
    allcols = row.findAll('td')
    for col in allcols:
      thestrings = [unicode(s) for s in col.findAll(text=True)]
      thetext = ''.join(thestrings)
      result[-1].append(thetext)
  return result

def get_cve_ids():
    with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\cve_embedded_from2005.csv', 'r') as cve:
        for line in cve:
            cve_id = line.split(',')[0]
            cves_to_search.append(cve_id)

def get_table_from_website(cve_id):
    try:
        response = urllib2.urlopen(website + cve_id)
    except Exception as e:
        print 'Problem access website of ' + cve_id
    html = response.read()
    soup = BeautifulSoup(html)
    return soup.select('table#vulnprodstable')[0]

if __name__ == '__main__':
    get_cve_ids()
    for cve_id in cves_to_search:
        try:
            table = get_table_from_website(cve_id)
            #sleep(1) # sleep 2 secs to avoid disables
        except Exception as e:
            print 'Problem processing CVE: ' + cve_id
            print 'Error: ' + e.message
        for item in makelist(table):
            if item != []:
                try:
                    target_class = item[1].strip()
                    target = item[3].strip()
                    if target_class.lower() not in count:
                        count[target_class.lower()] = {}
                        count[target_class.lower()][target.lower()] = 1
                    else:
                        if target.lower() not in count[target_class.lower()]:
                            count[target_class.lower()][target.lower()] = 1
                        else:
                            count[target_class.lower()][target.lower()] += 1
                except Exception as e:
                    print 'Error during processing: ' + cve_id + '\t' + e.message
                    continue
    for item in count.keys():
        with open('C:\\BME\AIT\\repository\\attack taxonomy\\cve\\targets_' + item + '.csv', 'w') as result:
            for i in count[item].keys():
                result.write(i + ',' + str(count[item][i])+ '\n')

